var expect, iTransactable;
if(typeof(window)==="undefined") {
	expect = require("chai").expect;
	iTransactable = require("../index.js");
}

function Person() {
	
}
Person = iTransactable(Person);
var p1 = new Person(),
	p2 = new Person(),
	p3 = new Person();

describe("iTransactable ", function() {
	describe("individual objects are transactable",function() {
		it("supports direct rollback", function(done) {
			var transaction = p1.beginTransaction();
			p1.name = "Joe";
			expect(p1.name).to.equal("Joe");
			transaction.rollback().then((committed) => {
				expect(committed).to.equal(false);
				expect(p1.name).to.equal(undefined);
				done();
			})
		});
	});
	describe("multiple objects are transactable",function() {
		it("supports direct rollback", function(done) {
			var transaction = iTransactable.beginTransaction([p2,p3]);
			p2.name = "Joe";
			expect(p2.name).to.equal("Joe");
			p3.name = "Mary";
			expect(p3.name).to.equal("Mary");
			transaction.rollback().then((committed) => {
				expect(committed).to.equal(false);
				expect(p2.name).to.equal(undefined);
				expect(p3.name).to.equal(undefined);
				done();
			})
		});
	});
});
